from .base_controller import BaseController
from .media_controller import MediaController
from .message_processor import MessageProcessor
from .message_retrieval import MessageRetrieval
from .chat_controller import ChatController

class MessageController(BaseController):
    @classmethod
    def process_new_messages(cls):
        return MessageProcessor.process_new_messages()
    
    @classmethod
    def handle_media_download(cls, msg, message_type, timestamp):
        return MediaController.handle_media_download(msg, message_type, timestamp)

    @classmethod
    def get_messages_by_author(cls, page=1):
        return MessageRetrieval.get_messages_by_author(page)

    @classmethod
    def get_duplicate_count(cls):
        return MessageRetrieval.get_duplicate_count()  # Remove cls parameter

    @classmethod
    def get_messages(cls, page=1):
        return MessageRetrieval.get_messages(page)

    @classmethod
    def search_messages(cls, query='', search_type='all', page=1):
        return MessageRetrieval.search_messages(query, search_type, page)

    @classmethod
    def process_chats(cls):
        return ChatController.process_chats()
